-----------------------------
-- INIT
-----------------------------

local addon, ns = ...
local cfg = CreateFrame("Frame")
local mediaFolder = "Interface\\AddOns\\oUF_sqw\\media\\"	-- don't touch this ...

-----------------------------
-- CONFIG
-----------------------------

-- Units
cfg.showtot = true -- show target of target frame
cfg.showpet = true -- show pet frame
cfg.showpartypet = true -- show party pet frame
cfg.showfocus = true -- show focus frame
cfg.showfocustarget = true -- show focus target frame
cfg.ShowPlayerName = true -- show player's name and level
cfg.showBossFrames = true -- show boss frame
-- cfg.portraits = true
cfg.showportraitplayer = true -- show player's portrait
cfg.showportraittarget = true -- show target's portrait

-- Raid and Party
cfg.ShowParty = true -- show party frames
cfg.party_leader_icon = true -- Show Leader Icon
cfg.ShowRaid = false -- show raid frames
cfg.showportraitparty = true -- show party's portrait

-- Positioning
cfg.PlayerX = -270 -- Player frame's x-offset position from the relative point of the screen
cfg.PlayerY = -260 -- Player frame's y-offset position from the relative point of the screen
cfg.PlayerRelativePoint = "CENTER" -- Player frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"
cfg.TargetX = 270 -- Target frame's x-offset position from the relative point of the screen
cfg.TargetY = -260 -- Target frame's y-offset position from the relative point of the screen
cfg.TargetRelativePoint = "CENTER" -- Target frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"
cfg.TotX = 0 -- Target of target frame's x-offset position from the relative point of the screen
cfg.TotY = 8 -- Target of target frame's y-offset position from the relative point of the screen
cfg.TotRelativePoint = "TOPRIGHT" -- Target of target frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"  cfg.PartyX = -290

-- Party Frames Horizontal Position
cfg.FocusX = 450 -- Focus frame's x-offset position from the relative point of the screen
cfg.FocusY = 50 -- Focus frame's y-offset position from the relative point of the screen
cfg.FocusRelativePoint = "TOP" -- Focus frame's reference point of the screen used for X and Y offsets.
cfg.FocusTargetX = 16
cfg.FocusTargetY = 4
cfg.FocusTargetRelativePoint = "TOPRIGHT" -- Focus target frame's reference point of the screen used for X and Y offsets.
cfg.PartyX = -900 -- Party Frames Horizontal Position
cfg.PartyY = 50 -- Party Frames Vertical Position
cfg.RaidX = -1050 -- Party Frames Horizontal Position
cfg.RaidY = 370 -- Party Frames Vertical Position
--[[cfg.RaidX = 250 -- Party Frames Horizontal Position
cfg.RaidY = -540 -- Party Frames Vertical Position]]
cfg.BossX = 750 -- Boss Frames Horizontal Position
cfg.BossY = 250 -- Boss Frames Vertical Position
cfg.TankX = 30 -- Main Tank Frames Horizontal Position
cfg.TankY = -230 -- Main Tank Frames Vertical Position

-- Auras
cfg.showTargetBuffs = true -- show target buffs
cfg.showTargetDebuffs = true -- show target debuffs
cfg.debuffsOnlyShowPlayer = true -- only show your debuffs on target
cfg.buffsOnlyShowPlayer = true -- only show your buffs
cfg.showBossBuffs = false -- show target buffs
cfg.showBossDebuffs = true -- show target debuffs

-- Plugins
cfg.enableDebuffHighlight = true -- enable *dispellable* debuff highlight for raid frames
cfg.showRaidDebuffs = true -- enable important debuff icons to show on raid units
cfg.showAuraWatch = false -- enable display of HoTs and important player buffs/debuffs on raid frames (broken)
cfg.CombatFeedback = false -- enable standard oUF_CombatFeedback
cfg.FloatingCombatFeedback = false -- enable oUF_FloatingCombatFeedback by lightspark
cfg.FountainMode = false -- enable fountain mode for oUF_CombatFeedback

-- Misc
cfg.showExperience = false -- show experience bar
cfg.showRunebar = true -- show DK's rune bar
cfg.showClassbar = true -- Soul shards, arcane charges, holy power and chi
-- cfg.showEclipsebar = true -- show druid's Eclipse bar
-- cfg.showShards = true -- warlock bars
--cfg.showTotemBar = false -- show Shaman Totem timer bar (broken)
cfg.showVengeance = true -- show tank Vengeance bar
cfg.RCheckIcon = true -- show raid check icon
cfg.Castbars = true -- use built-in castbars
cfg.ShowIncHeals = true -- Show incoming heals in player and raid frames
cfg.showLFDIcons = true -- Show dungeon role icons in raid/party
cfg.statusbar_texture = mediaFolder.."Minimalist"
cfg.powerbar_texture = mediaFolder.."Minimalist"
cfg.xpbar_texture = mediaFolder.."xpbar"
cfg.backdrop_texture = mediaFolder.."Minimalist"
cfg.highlight_texture = mediaFolder.."raidbg"
cfg.debuffhighlight_texture = mediaFolder.."debuff_highlight"
cfg.backdrop_edge_texture = mediaFolder.."backdrop_edge"
cfg.debuffBorder = mediaFolder.."iconborder"
cfg.spark = mediaFolder.."spark"
--cfg.font = mediaFolder.."sqw.ttf"--[[Interface\Addons\SharedMediaAdditionalFonts\fonts\Montserrat-Regular.ttf]]--mediaFolder.."expressway.ttf"
--cfg.font = mediaFolder.."Roboto-Bold.ttf"
cfg.font = mediaFolder.."CalibriBold.ttf"
cfg.healthbarfontsize = 50--36
cfg.smallfont = mediaFolder.."Calibri.ttf"--expressway.ttf"
cfg.raidScale = 1 -- scale factor for raid frames
cfg.partyScale = 1 -- scale factor for party frames
cfg.scale = 1 -- scale factor for all other frames
cfg.playerportraitheight = 40
cfg.playerportraitwidth = 50
cfg.targetportraitheight = 40
cfg.targetportraitwidth = 50
cfg.partyportraitheight = 35
cfg.partyportraitwidth = 35

-----------------------------
-- HANDOVER
-----------------------------

ns.cfg = cfg
